#!/usr/bin/perl -w 
package esmith::FormMagick::Panel::rsync;

use strict;
use warnings;
use esmith::ConfigDB;
use esmith::FormMagick;

our @ISA = qw(esmith::FormMagick Exporter);

our @EXPORT = qw();

our $VERSION = sprintf '%d.%03d', q$Revision: 1.1 $ =~ /: (\d+).(\d+)/;

our $db = esmith::ConfigDB->open or die "Couldn't open ConfigDB\n";

sub get_status
{
    return $db->get_prop("rsync", "status");
}

sub get_include
{
    my $self = shift;
    my $q = $self->{cgi};

    my $Include = $db->get_prop("rsync", "Include");

    if ("$Include" eq "")
        {
        use esmith::Backup;
        my $backup = esmith::Backup->new();
        return join "\n", map { "/" . $_ } sort($backup->restore_list);
        }
        else
        {
        my @Include = sort(split(/,/, $Include));
        return join "\n", map { "$_" } @Include;
        }
}

sub get_exclude
{
    my $self = shift;
    my $q = $self->{cgi};

    my $Exclude = $db->get_prop("rsync", "Exclude");
    my @Exclude = sort(split(/,/, $Exclude));

    return join "\n", map { "$_" } @Exclude;
}

sub get_mount
{
    return $db->get_prop("rsync", "Mount");
}

sub get_reminderTime
{
    return $db->get_prop("rsync", "reminderTime");
}

sub get_backupTime
{
    return $db->get_prop("rsync", "backupTime");
}

sub change_settings
{
    my $fm = shift;
    my $q = $fm->{'cgi'};

    $db->set_prop('rsync', 'status', $q->param("status"));
    $db->set_prop('rsync', 'Mount', $q->param("mount"));
    $db->set_prop('rsync', 'reminderTime', $q->param("remindertime"));
    $db->set_prop('rsync', 'backupTime', $q->param("backuptime"));

    my $Include = $q->param("include");
    $Include =~ s/\r\n/,/g;
    $db->set_prop('rsync', 'Include', "$Include");

    my $Exclude = $q->param("exclude");
    $Exclude =~ s/\r\n/,/g;
    $db->set_prop('rsync', 'Exclude', "$Exclude");

    unless ( system ("/sbin/e-smith/signal-event", "conf-rsync") == 0 )
    {
        $fm->error('ERROR_UPDATING');
        return undef;
    }

    $fm->success('SUCCESS');
}
1;
